# Meme Share App
**What** - An app for random Reddit memes with the option to share it as well!

**Why** - Wanted to learn about integrating APIs with Android apps. (I learnt more than this)

**How did it get created** - Followed [Anuj Bhaiya's](https://www.youtube.com/channel/UC58_wzhvJta3hDSPvRLDAqg) playlist on [Android Development](https://www.youtube.com/playlist?list=PLUcsbZa0qzu3Mri2tL1FzZy-5SX75UJfb) - from videos 5 to 7. Credits to him for such an awesome playlist!

<br>

**New Things experimented with and learnt** -
1. The app uses [view binding](https://developer.android.com/topic/libraries/view-binding) instead of `findViewById`.
2. Since the `kotlin-android-extensions` Gradle extension has been [depreciated](https://stackoverflow.com/questions/65179275/the-kotlin-android-extensions-gradle-plugin-is-deprecated), I learnt about using view binding. Read about this on Google's blog [post](https://android-developers.googleblog.com/2020/11/the-future-of-kotlin-android-extensions.html).
3. Learnt about various XML tags to simplify symmetric design and make the app look lovely.
4. Implementing [Glide](https://github.com/bumptech/glide) and [Volley](https://developer.android.com/training/volley) libraries in an Andriod app.

<br>

## Features to implement (to learn more about Android dev)
- Dark and light mode with one button switch.
- Giving options to view memes from subreddits like r/wholesomememes, r/dankmemes. etc.
- Creating an about page to give more info about the app and contributors (if any) to this app.

<br>

## Credits (not in any particular order)
1. [Anuj Bhaiya](https://www.youtube.com/channel/UC58_wzhvJta3hDSPvRLDAqg) for his playlist :)
2. [Dev Daksan](https://github.com/D3vd) for the amazing random reddit meme API!
3. Google, Startpage, Duckduckgo - amazing search engines! They helped me in removing errors while creating the app.
4. Google's blog posts on view binding, Volley library, etc.
5. College Friends (let's keep them anonymous) for installing the app and giving feedback on how it is.

<br>

(NOTE - if you want to suggest features/contribute on this app, please DM me on [Twitter](https://twitter.com/InfoseccGurung))
